/*
 * *****************************************************************
 * *                                                               *
 * *       Copyright (c) Fast Corporation, 1997                    *
 * *                                                               *
 * *   All Rights Reserved.  Unpublished rights  reserved  under   *
 * *   the copyright laws of the Japan.                            *
 * *                                                               *
 * *   The software contained on this media  is  proprietary  to   *
 * *   and  embodies  the  confidential  technology  of  Fast      *
 * *   Corporation.  Possession, use,  duplication  or             *
 * *   dissemination of the software and media is authorized only  *
 * *   pursuant to a valid written license from Fast Corporation.  *
 * *                                                               *
 * *****************************************************************
 */

/* brbXOw@b|khmjʐMTvvO */
/* 		C[`  C_L98W.C */
/*m쐬ҁnA.Kameda */
/*
ړIF	vłb|khmjɂʐMvOiobXWj
֐F	
F	Ver 1.0		97/08/19
		Ver 2.0		99/05/20
LF	XOw(C_L90X.BIN,C_L90X.EXE)Ƃ̒ʐMvO
        菇                            90X          PC
        @XOwփR}h('F')MB      | <--- F --- |
        AXOwR}h('O')MB    | ---- O --> |
        BXOwփt@CMB           | <= file == |
        CXOwR}h('F')MB    | ---- F --> |
        DXOwփR}h('O')MB      | <--- O --- |
        EXOwt@CMB         | == file => |
*/


/*
 * Include compiler runtime library
 */
#include <windows.h>
#include <winnt.h>
#include <winbase.h>


/*
 * Include CSC90X library
 */
#include "csc_ctrl.h"		// vŒʐMCu


/*
 * Include CSC90X common local
 */
#include "resource.h"


/*
 * f[^A`
 */
static HWND		hWndGb;
#define	MAX_FILE_PATH	512


/*
 * vg^Cv錾
 */
BOOL	InitApplication( HINSTANCE );
BOOL	InitInstance( HINSTANCE , INT );
LRESULT CALLBACK	MainWndProc( HWND, UINT, WPARAM, LPARAM );
BOOL	CL98W_CommStart( VOID );
BOOL	CL98W_FileSend( INT );
BOOL	CL98W_FileRecv( INT );
VOID	CL98W_Indicator( LONG, LONG );


// ----------------------------------------------------------------------------
int 	WINAPI WinMain( HINSTANCE hInstance,  HINSTANCE hPrevInstance, 
                    LPSTR lpszCmdLine, int nWinMode )
{
    MSG 	msg;
	
    if( !hPrevInstance )
    {	if( !InitApplication( hInstance ) )		//ع݂ƂĂ̏
        return FALSE;
    }
	
    if( !InitInstance( hInstance, nWinMode ) )	//ع.ݽݽƂĂ̏
	{
       return FALSE;
	}
	
    while( GetMessage( &msg, NULL, 0, 0 ) )		// үނ̊l
    {
		TranslateMessage( &msg );				// үނ̕ϊ
    	DispatchMessage(  &msg );				// үނ̔
	}
	
    return msg.wParam;							// Iނ
}


// ع݂ƂĂ̏
BOOL InitApplication( HANDLE hInstance )
{
    WNDCLASS  wc;
	
    wc.style = CS_VREDRAW | CS_HREDRAW; 					// wnނύXꂽĕ`
    wc.lpfnWndProc = MainWndProc;							// үޏ֐
    wc.cbClsExtra = 0;										// ʐMp̈i޳.׽j
    wc.cbWndExtra = 0;										// ʐMp̈i޳j
    wc.hInstance = hInstance;								// ع.ݽݽ
    wc.hIcon = LoadIcon(NULL,IDI_APPLICATION);				// ŏߎ̱݂̎w
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);				// قق̐ݒ
	
    wc.hbrBackground = CreateSolidBrush(RGB(128,128,255)); 
    wc.hbrBackground = CreateSolidBrush(RGB(128,128,128)); 
	
	wc.lpszMenuName =  "MyMainMenu";			// ***.rcŒ`ƭ̖O
    wc.lpszClassName = "Clink98Win";			// ޳.׽CreateWindowŎgp
	
    return RegisterClass( &wc );				// ׽̓o^
}


// ع.ݽݽƂĂ̏
BOOL InitInstance( HINSTANCE hInstance, INT nWinMode )
{
    HWND            hWnd;		// ޳.
	
    hWnd = CreateWindow(						// ޳̍쐬
        "Clink98Win",							// ޳.׽
        "b|khmjʐMTvvO",	// ްւ̕\
        WS_OVERLAPPEDWINDOW,					// ޳̽  ł̽
        CW_USEDEFAULT,							// ޳̕\ʒuX тɔC
	    CW_USEDEFAULT,							// ޳̕\ʒuY тɔC
	    CW_USEDEFAULT,							// ޳̑傫X   тɔC
        CW_USEDEFAULT,							// ޳̑傫Y   тɔC
        HWND_DESKTOP,							// e޳ف@޽į(NULL)
        NULL,									// ƭ.ف@޳.׽Ŏw肵ƭgȂNULLɂ
        hInstance,								// ع.ݽݽ
        NULL									// ʐMp߲
    	);
	
    if( !hWnd )
    {
	    return FALSE;
    }
	hWndGb = hWnd;
    
    ShowWindow( hWnd, nWinMode );		// ޳̕\
    UpdateWindow( hWnd );
    return TRUE;
}


// bZ[W
LRESULT CALLBACK     MainWndProc(HWND hWnd,UINT message, WPARAM wParam, 
                                                    LPARAM lParam)
{
	switch( message )
	{
		case	WM_DESTROY:		// AvI
			PostQuitMessage( 0 );
			break;
		
		case	WM_COMMAND:		// Cxg
			switch( wParam )
			{
				case	ID_MENUITEM_START:			// MJn
					if( IDOK == MessageBox( hWnd, "XOwĂB", 
											"MJn", MB_OKCANCEL ) )
					{
						CL98W_CommStart();
					}
					break;
				
				case	ID_MENUITEM_EXIT:			// I
					PostQuitMessage( 0 );
					break;
			}
			break;
		
		default:
			return DefWindowProc( hWnd, message, wParam, lParam );
	}
	return 0;
}


// MJn
BOOL	CL98W_CommStart()
/*
[߂l]	TRUE	
			FALSE	s
*/
{
	INT		iComHandle;
	BOOL	boRet;
	
	boRet = FALSE;
	
	// b|khmj|[g̐ݒ
	CSCCommSetClinkParam( FIRST, L8, XCOFF, PNONE, S1, B9600, NODE_0 );	// ǃm[h͂O
	
	// C^[tFCX̏
	iComHandle = CSCCommInit();
	if( 0 != iComHandle )
	{
		// t@C̑M
		boRet = CL98W_FileSend( iComHandle );
		
		// t@C̎M
		if( boRet )	boRet = CL98W_FileRecv( iComHandle );
		
		// C^[tFCX̏I
		CSCCommFinish( iComHandle );
	}
	
	return boRet;
}


// t@C̑M
BOOL	CL98W_FileSend( INT iComHandle )
/*
[߂l]	TRUE	
			FALSE	s
*/
{
	BOOL	boRet;
	HANDLE	hFile;
	CHAR	cBuff[100];
	CHAR	cSendBuff[10];
	CHAR	cRecvBuff[10];
	HDC		hDC = GetDC( hWndGb );
	static SECURITY_ATTRIBUTES sa =
			{
				sizeof(SECURITY_ATTRIBUTES),
				NULL,
				TRUE
			};
	
	// R}hif[^j̑M
	strcpy( cBuff, "R}hM" );
	TextOut( hDC, 0, 0, cBuff, strlen( cBuff ) );
	strcpy( cSendBuff, "F" );
	boRet = CSCCommPuts( iComHandle, cSendBuff, 1, NODE_8, 10 );
	if( boRet )
	{
		strcpy( cBuff, "R}hMF" );
		TextOut( hDC, 0, 0, cBuff, strlen( cBuff ) );
	}
	
	// R}hif[^j̎M
	if( boRet )
	{
		strcpy( cBuff, "R}hM" );
		TextOut( hDC, 0, 20, cBuff, strlen( cBuff ) );
		if( CSCCommGets( iComHandle, cRecvBuff, 1, NODE_8, 10 ) )
		{
			if( 'O' == cRecvBuff[0] )
			{
				strcpy( cBuff, "R}hMF" );
				TextOut( hDC, 0, 20, cBuff, strlen( cBuff ) );
				boRet = TRUE;
			}
			else	boRet = FALSE;
		}
		else	boRet = FALSE;
	}
	
	// t@C̑M
	if( boRet )
	{
		hFile = CreateFile(	"SAMPLE.D91",
				GENERIC_READ,
				0,
				&sa,
				OPEN_EXISTING,
				FILE_ATTRIBUTE_NORMAL,
				0 );
		if( hFile != (HANDLE)NULL )
		{
			strcpy( cBuff, "t@C̑M" );
			TextOut( hDC, 0, 40, cBuff, strlen( cBuff ) );
			boRet = CSCCommLoad( iComHandle, USERFILE, NODE_8, hFile, CL98W_Indicator, 10 );
			if( boRet )
			{
				strcpy( cBuff, "t@C̑MF" );
				TextOut( hDC, 0, 40, cBuff, strlen( cBuff ) );
			}
			CloseHandle( hFile );
		}
		else	boRet = FALSE;
	}
	
	ReleaseDC( hWndGb, hDC );
	return boRet;
}


// t@C̎M
BOOL	CL98W_FileRecv( INT iComHandle )
/*
[߂l]	TRUE	
			FALSE	s
*/
{
	BOOL	boRet;
	HANDLE	hFile;
	CHAR	cBuff[100];
	CHAR	cSendBuff[10];
	CHAR	cRecvBuff[10];
	CHAR	cRevcPath[MAX_FILE_PATH];
	HDC		hDC = GetDC( hWndGb );
	static SECURITY_ATTRIBUTES sa =
			{
				sizeof(SECURITY_ATTRIBUTES),
				NULL,
				TRUE
			};
	
	// R}hif[^j̎M
	strcpy( cBuff, "R}hM" );
	TextOut( hDC, 0, 60, cBuff, strlen( cBuff ) );
	if( CSCCommGets( iComHandle, cRecvBuff, 1, NODE_8, 10 ) )
	{
		if( 'F' == cRecvBuff[0] )
		{
			strcpy( cBuff, "R}hMF" );
			TextOut( hDC, 0, 60, cBuff, strlen( cBuff ) );
			boRet = TRUE;
		}
		else	boRet = FALSE;
	}
	else	boRet = FALSE;
	
	// R}hif[^j̎M
	if( boRet )
	{
		strcpy( cBuff, "R}hM" );
		TextOut( hDC, 0, 80, cBuff, strlen( cBuff ) );
		strcpy( cSendBuff, "O" );
		boRet = CSCCommPuts( iComHandle, cSendBuff, 1, NODE_8, 10 );
		if( boRet )
		{
			strcpy( cBuff, "R}hMF" );
			TextOut( hDC, 0, 80, cBuff, strlen( cBuff ) );
		}
	}
	
	// t@C̎M
	if( boRet )
	{
		GetCurrentDirectory( MAX_FILE_PATH, cRevcPath );
		strcat( cRevcPath, "\\" );
		strcat( cRevcPath, "SAMPLE.DAT" );
		hFile = CreateFile(	cRevcPath,
							GENERIC_WRITE,
							0,
							&sa,
							CREATE_ALWAYS,
							FILE_ATTRIBUTE_NORMAL,
							0 );
		if( hFile != (HANDLE)NULL )
		{
			strcpy( cBuff, "t@C̎M" );
			TextOut( hDC, 0, 100, cBuff, strlen( cBuff ) );
			boRet = CSCCommUpLoad( iComHandle, NODE_8, hFile, CL98W_Indicator, 10 );
			if( boRet )
			{
				strcpy( cBuff, "t@C̎MF" );
				TextOut( hDC, 0, 100, cBuff, strlen( cBuff ) );
			}
			CloseHandle( hFile );
		}
		else	boRet = FALSE;
	}
	
	ReleaseDC( hWndGb, hDC );
	return boRet;
}


/* CWP[^[ */
VOID	CL98W_Indicator( LONG lTotalSize, LONG lSize )
{
	static LONG lSum;
	static LONG lSize10;
	static LONG lCnt;
	CHAR	cBuff[100];
	HDC		hDC = GetDC( hWndGb );
	
	if( lTotalSize )
	{
		lSize10 = lTotalSize / 10;
		lSum = 0;
		lCnt = 0;
		strcpy( cBuff, "Transferring" );
		TextOut( hDC, 0, 120, cBuff, strlen( cBuff ) );
		strcpy( cBuff, "                            " );
		TextOut( hDC, 0, 140, cBuff, strlen( cBuff ) );
	}
	lSum += lSize;
	while( lSum >= lSize10 )
	{
		if( lCnt < 10 )
		{
			strcpy( cBuff, "* " );
			TextOut( hDC, lCnt*16, 140, cBuff, strlen( cBuff ) );
		}
		lSum -= lSize10;
		lCnt++;
	}
	
	ReleaseDC( hWndGb, hDC );
}

// ----------------------------------------------------------------------------
